## opencv 4.5.2

=== debian/changelog ===
opencv (4.5.2-2) bullseye; urgency=medium

  * repository: git://source.codeaurora.org/external/imx/opencv-imx.git
  * branch: 4.5.2_imx
  * commit: lf-5.10.35-2.0.0

 -- Laci Tele <laci@boundarydevices.com>  Sat, 28 Aug 2021 07:16:05 -0700
