=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

BUILDDIR = obj-$(DEB_HOST_MULTIARCH)

CMAKE_ARCH_FLAGS :=

#
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
####################
# cross build
    export SYSROOT = /var/lib/schroot/chroots/buster-opencv-sysroot-arm64
    export CC  = $(DEB_HOST_GNU_TYPE)-gcc-10
    export CXX = $(DEB_HOST_GNU_TYPE)-g++-10
    export CROSS_COMPILE = $(DEB_HOST_GNU_TYPE)-
    CMAKE_ARCH_FLAGS += -DCMAKE_CROSSCOMPILING=ON
    CMAKE_ARCH_FLAGS += -DCMAKE_SYSROOT="$(SYSROOT)"
    CMAKE_ARCH_FLAGS += -DCMAKE_FIND_ROOT_PATH="$(SYSROOT)"
    CMAKE_ARCH_FLAGS += -DCMAKE_FIND_ROOT_PATH_MODE_PROGRAM=NEVER
    CMAKE_ARCH_FLAGS += -DCMAKE_FIND_ROOT_PATH_MODE_LIBRARY=ONLY
    CMAKE_ARCH_FLAGS += -DCMAKE_FIND_ROOT_PATH_MODE_INCLUDE=ONLY
    CMAKE_ARCH_FLAGS += -DCMAKE_FIND_ROOT_PATH_MODE_PACKAGE=ONLY

    export PKG_CONFIG_LIBDIR      = $(SYSROOT)/usr/lib/pkgconfig:$(SYSROOT)/usr/lib/$(DEB_HOST_GNU_TYPE)/pkgconfig:$(SYSROOT)/usr/share/pkgconfig
    export PKG_CONFIG_SYSROOT_DIR = $(SYSROOT)
else
    export CC  = /usr/lib/distcc/bin/gcc-10
    export CXX = /usr/lib/distcc/bin/g++-10
endif

export CFLAGS   = -DCL_VERSION_1_0=1 -DCL_VERSION_1_1=1 -DCL_VERSION_1_2=1 -DCL_TARGET_OPENCL_VERSION=120 -I/usr/include/vivante
export CXXFLAGS = -DCL_VERSION_1_0=1 -DCL_VERSION_1_1=1 -DCL_VERSION_1_2=1 -DCL_TARGET_OPENCL_VERSION=120 -I/usr/include/vivante
export LDFLAGS  = -Wl,-O1 -Wl,--hash-style=gnu -Wl,--as-needed

CMAKE_ARCH_FLAGS += -DOPENCV_ICV_HASH="7421de0095c7a39162ae13a6098782f9"
CMAKE_ARCH_FLAGS += -DIPPROOT="$(CURDIR)/ippicv_lnx"
#
CMAKE_ARCH_FLAGS += -DBUILD_opencv_freetype=ON
CMAKE_ARCH_FLAGS += -DWITH_OPENCLAMDBLAS=OFF
CMAKE_ARCH_FLAGS += -DWITH_OPENCLAMDFFT=OFF
CMAKE_ARCH_FLAGS += -DWITH_ADE=ON
CMAKE_ARCH_FLAGS += -Dade_DIR=/usr/lib
CMAKE_ARCH_FLAGS += -DBUILD_TESTS=OFF
CMAKE_ARCH_FLAGS += -DINSTALL_TESTS=OFF
CMAKE_ARCH_FLAGS += -DBUILD_opencv_text=ON
CMAKE_ARCH_FLAGS += -DWITH_OPENVX=OFF
CMAKE_ARCH_FLAGS += -DOPENCV_EXTRA_MODULES_PATH=$(CURDIR)/contrib/modules
#
#CMAKE_ARCH_FLAGS += -DOPENCV_ALLOW_DOWNLOADS=OFF
#CMAKE_ARCH_FLAGS += -DWITH_1394=OFF
#CMAKE_ARCH_FLAGS += -DWITH_V4L=OFF
#CMAKE_ARCH_FLAGS += -DCMAKE_NO_SYSTEM_FROM_IMPORTED=1 \
#CMAKE_ARCH_FLAGS += -DOPENCV_DOWNLOAD_PATH=/4.5.2.imx-r0/downloads
#CMAKE_ARCH_FLAGS += -DPYTHON3_NUMPY_INCLUDE_DIRS:PATH=/usr/lib/python3.9/site-packages/numpy/core/include

# Comply with Debian architectures baseline.
# See cmake/OpenCVCompilerOptimizations.cmake for a list of known features.
# Reference: https://github.com/opencv/opencv/wiki/CPU-optimizations-build-options
ifeq ($(DEB_HOST_ARCH_CPU),amd64)
 # Only SSE2 on amd64
 CMAKE_ARCH_FLAGS += -DCPU_BASELINE="SSE2"
 CMAKE_ARCH_FLAGS += -DCPU_BASELINE_DISABLE="SSE3"
else ifeq ($(DEB_HOST_ARCH_CPU),armhf)
 CMAKE_ARCH_FLAGS += -DCPU_BASELINE_DISABLE="VFPV3,NEON"
 CMAKE_ARCH_FLAGS += -DCPU_DISPATCH="VFPV3,NEON"
else ifeq ($(DEB_HOST_ARCH_CPU),i386)
 # Be extra sure SSE is not picked up on i386
 CMAKE_ARCH_FLAGS += -DCPU_BASELINE_DISABLE="SSE,SSE2"
else ifeq ($(DEB_HOST_ARCH_CPU),ppc64el)
 # VSX for Power8, VSX3 for Power9
 CMAKE_ARCH_FLAGS += -DCPU_BASELINE="VSX"
 CMAKE_ARCH_FLAGS += -DCPU_DISPATCH="VSX3"
endif

# TBB support
ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 arm64 armel armhf i386 mips mips64el mipsel ppc64el s390x powerpc powerpcspe riscv64 ppc64 sh4 sparc64))
CMAKE_ARCH_FLAGS += -DWITH_TBB=ON
else
CMAKE_ARCH_FLAGS += -DWITH_TBB=OFF
endif

# Linux-specific stuff
ifeq ($(DEB_HOST_ARCH_OS),linux)
CMAKE_ARCH_FLAGS += -DWITH_1394=ON -DWITH_V4L=OFF -DWITH_LIBV4L=ON
else
CMAKE_ARCH_FLAGS += -DWITH_1394=OFF -DWITH_V4L=OFF
endif

# Java support
ifeq (,$(findstring $(DEB_HOST_ARCH), hppa hurd-i386 kfreebsd-i386 kfreebsd-amd64))
CMAKE_ARCH_FLAGS += -DBUILD_JAVA=ON
endif

# mitigate compiler OOM during build
ifeq ($(DEB_HOST_ARCH),mipsel)
export DEB_BUILD_OPTIONS=noopt
CXXFLAGS+=-gsplit-dwarf
endif

# For Java
export JAVA_HOME=/usr/lib/jvm/default-java

# NOTES:
# 1. we set WITH_QT=OFF because files under modules/highgui/src/files_Qt/Milky
#    have been filtered, which are required for the QT build.
CMAKE_FLAGS = \
	-GNinja \
	-DANT_EXECUTABLE=/usr/bin/ant \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_PROTOBUF=OFF \
	-DBUILD_PERF_TESTS=OFF \
	-DBUILD_opencv_dnn=ON \
	-DBUILD_opencv_dnn_modern=ON \
	-DBUILD_opencv_face=ON \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
	-DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
	-DCMAKE_EXE_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
	-DCMAKE_INSTALL_LIBDIR="lib/$(DEB_HOST_MULTIARCH)" \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_SKIP_RPATH=ON \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_FIND_DEBUG_MODE=ON \
	-DENABLE_PRECOMPILED_HEADERS=OFF \
	-DINSTALL_C_EXAMPLES=ON \
	-DINSTALL_PYTHON_EXAMPLES=ON \
	-DOPENCL_INCLUDE_DIR:PATH="/usr/include/vivante/CL/" \
	-DOPENCV_EXTRA_MODULES_PATH="$(CURDIR)/contrib/modules" \
	-DOPENCV_MATHJAX_RELPATH=/usr/share/javascript/mathjax/ \
	-DOPENCV_SKIP_PYTHON_LOADER=ON \
	-DOPENCV_GENERATE_PKGCONFIG=ON \
	-DOPENCV_LAPACK_FIND_PACKAGE_ONLY=ON \
	-DOpenGL_GL_PREFERENCE=GLVND \
	-DPROTOBUF_UPDATE_FILES=ON \
	-DWITH_CAROTENE=ON \
	-DWITH_CUDA=OFF \
	-DWITH_EIGEN=ON \
	-DWITH_FFMPEG=OFF \
	-DWITH_GDAL=OFF \
	-DWITH_GDCM=ON \
	-DWITH_GSTREAMER=ON \
	-DWITH_GPHOTO2=ON \
	-DWITH_GTK=ON \
	-DWITH_IPP=OFF \
	-DWITH_ITT=OFF \
	-DWITH_JASPER=OFF \
	-DWITH_JPEG=ON \
	-DWITH_LAPACK=ON \
	-DWITH_NGRAPH=OFF \
	-DWITH_OPENCL=ON \
	-DWITH_OPENEXR=ON \
	-DWITH_OPENGL=ON \
	-DWITH_PNG=ON \
	-DWITH_PROTOBUF=ON \
	-DWITH_PVAPI=ON \
	-DWITH_QT=OFF \
	-DWITH_QUIRC=OFF \
	-DWITH_TIFF=ON \
	-DWITH_UNICAP=OFF \
	-DWITH_VTK=ON \
	-DWITH_XINE=OFF \
	-DPYTHON3_NUMPY_INCLUDE_DIRS:PATH=$(SYSROOT)/usr/lib/python3/dist-packages/numpy/core/include \
	$(CMAKE_ARCH_FLAGS)

%:
ifeq (,$(findstring $(DEB_HOST_ARCH), hppa hurd-i386 kfreebsd-i386 kfreebsd-amd64))
	dh $@ --with python3,javahelper,jh_maven_repo_helper
else
	dh $@ --with python3
endif

override_dh_auto_clean:
	dh_auto_clean -B $(BUILDDIR)
	dh_auto_clean -B $(BUILDDIR)-static


override_dh_auto_configure:
	# dynamicly linked
	dh_auto_configure -B $(BUILDDIR) \
		-- $(CMAKE_FLAGS) \
		-DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
		-DBUILD_SHARED_LIBS=ON -DBUILD_DOCS=ON \
		-DBUILD_TESTS=OFF
	# statically linked
	dh_auto_configure -B $(BUILDDIR)-static \
		-- $(CMAKE_FLAGS) \
		-DBUILD_SHARED_LIBS=OFF -DBUILD_DOCS=OFF \
		-DBUILD_TESTS=OFF

override_dh_auto_build:
	# documentation
	dh_auto_build -B $(BUILDDIR) -- doxygen
ifneq (,$(findstring $(DEB_HOST_ARCH), mipsel))
	# dynamically linked
	dh_auto_build --no-parallel -B $(BUILDDIR)
	# statically linked
	dh_auto_build --no-parallel -B $(BUILDDIR)-static
else
	# dynamically linked
	dh_auto_build -B $(BUILDDIR)
	# statically linked
	dh_auto_build -B $(BUILDDIR)-static
endif

override_dh_auto_test:
ifeq ($(DEB_HOST_ARCH),mipsel)
	true # Don't run the tests at all
else
	-LD_LIBRARY_PATH=$(shell realpath $(BUILDDIR))/lib dh_auto_test
endif

ifeq ($(DEB_HOST_ARCH),mipsel)
override_dh_dwz:
	true # mipsel would FTBFS, possibly due to out-of-memory
endif

override_dh_auto_install:
	dh_auto_install -B $(BUILDDIR)

execute_before_dh_install:
	# put the static libs together with the rest of the stuff
	cp -v $(BUILDDIR)-static/lib/*.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	-find debian/tmp -type f -name jquery.js -delete
	-find debian/tmp -type f -name '*.supp' -delete
	-find debian/tmp -type d -empty -delete
	cp -a $(CURDIR)/modules/dnn/include/opencv2                   $(CURDIR)/debian/tmp/usr/include/opencv4
	cp -a $(CURDIR)/modules/gapi/include/opencv2                  $(CURDIR)/debian/tmp/usr/include/opencv4
	cp -a $(CURDIR)/contrib/modules/text/include/opencv2          $(CURDIR)/debian/tmp/usr/include/opencv4
	cp -a $(CURDIR)/contrib/modules/dnn_objdetect/include/opencv2 $(CURDIR)/debian/tmp/usr/include/opencv4
	cp -a $(CURDIR)/contrib/modules/superres/include/opencv2      $(CURDIR)/debian/tmp/usr/include/opencv4
	rm -rf $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_GNU_TYPE)/opencv4
