=== debian/changelog ===
opencv (4.5.3+dfsg-1ubuntu1) impish; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Adjust opencv breaks.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 25 Aug 2021 06:52:06 +0200

opencv (4.5.3+dfsg-1) unstable; urgency=medium

  * New upstream version 4.5.3+dfsg.
  * Add barcode and wechat-qrcode libraries to libopencv-contrib package.
  * Add opencv_model_diagnostics to libopencv-dev.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 23 Aug 2021 15:46:54 +0900

opencv (4.5.1+dfsg-5ubuntu1) impish; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Adjust opencv breaks.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 22 Jun 2021 14:55:24 +0200

opencv (4.5.1+dfsg-4ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Adjust opencv breaks.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 05 Mar 2021 14:26:46 +0100

opencv (4.5.1+dfsg-3ubuntu1) hirsute; urgency=medium

  * Adjust opencv breaks.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 31 Dec 2020 16:06:14 +0100
