=== debian/control ===
--- 
+++ 
@@ -10,7 +10,6 @@
                debhelper-compat (= 13),
                default-jdk [!hppa !hurd-any !kfreebsd-any],
                dh-python,
-               dh-exec,
                doxygen,
                javahelper,
                ninja-build,
@@ -175,7 +174,7 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
-Breaks: libvisp-core-dev (<< 3.3.0-5+b1)
+Breaks: libvisp-core-dev (<< 3.3.0-5build1)
 Description: computer vision core library
  This package contains the OpenCV (Open Computer Vision) core runtime libraries.
  .
@@ -275,3 +274,4 @@
 
 Package: libopencv-imgcodecs-dev
 Architecture: any
+Multi-Arch: same
